package com.ruoyi.system.domain.visit;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class VisitFreePlanModelExample implements Serializable {

    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private static final long serialVersionUID = 1L;

    public VisitFreePlanModelExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria implements Serializable {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andPlanTitleIsNull() {
            addCriterion("plan_title is null");
            return (Criteria) this;
        }

        public Criteria andPlanTitleIsNotNull() {
            addCriterion("plan_title is not null");
            return (Criteria) this;
        }

        public Criteria andPlanTitleEqualTo(String value) {
            addCriterion("plan_title =", value, "planTitle");
            return (Criteria) this;
        }

        public Criteria andPlanTitleNotEqualTo(String value) {
            addCriterion("plan_title <>", value, "planTitle");
            return (Criteria) this;
        }

        public Criteria andPlanTitleGreaterThan(String value) {
            addCriterion("plan_title >", value, "planTitle");
            return (Criteria) this;
        }

        public Criteria andPlanTitleGreaterThanOrEqualTo(String value) {
            addCriterion("plan_title >=", value, "planTitle");
            return (Criteria) this;
        }

        public Criteria andPlanTitleLessThan(String value) {
            addCriterion("plan_title <", value, "planTitle");
            return (Criteria) this;
        }

        public Criteria andPlanTitleLessThanOrEqualTo(String value) {
            addCriterion("plan_title <=", value, "planTitle");
            return (Criteria) this;
        }

        public Criteria andPlanTitleLike(String value) {
            addCriterion("plan_title like", value, "planTitle");
            return (Criteria) this;
        }

        public Criteria andPlanTitleNotLike(String value) {
            addCriterion("plan_title not like", value, "planTitle");
            return (Criteria) this;
        }

        public Criteria andPlanTitleIn(List<String> values) {
            addCriterion("plan_title in", values, "planTitle");
            return (Criteria) this;
        }

        public Criteria andPlanTitleNotIn(List<String> values) {
            addCriterion("plan_title not in", values, "planTitle");
            return (Criteria) this;
        }

        public Criteria andPlanTitleBetween(String value1, String value2) {
            addCriterion("plan_title between", value1, value2, "planTitle");
            return (Criteria) this;
        }

        public Criteria andPlanTitleNotBetween(String value1, String value2) {
            addCriterion("plan_title not between", value1, value2, "planTitle");
            return (Criteria) this;
        }

        public Criteria andPlanTypeIsNull() {
            addCriterion("plan_type is null");
            return (Criteria) this;
        }

        public Criteria andPlanTypeIsNotNull() {
            addCriterion("plan_type is not null");
            return (Criteria) this;
        }

        public Criteria andPlanTypeEqualTo(String value) {
            addCriterion("plan_type =", value, "planType");
            return (Criteria) this;
        }

        public Criteria andVisitTypeEqualTo(String value) {
            addCriterion("visit_type =", value, "visitType");
            return (Criteria) this;
        }

        public Criteria andPlanTypeNotEqualTo(String value) {
            addCriterion("plan_type <>", value, "planType");
            return (Criteria) this;
        }

        public Criteria andPlanTypeGreaterThan(String value) {
            addCriterion("plan_type >", value, "planType");
            return (Criteria) this;
        }

        public Criteria andPlanTypeGreaterThanOrEqualTo(String value) {
            addCriterion("plan_type >=", value, "planType");
            return (Criteria) this;
        }

        public Criteria andPlanTypeLessThan(String value) {
            addCriterion("plan_type <", value, "planType");
            return (Criteria) this;
        }

        public Criteria andPlanTypeLessThanOrEqualTo(String value) {
            addCriterion("plan_type <=", value, "planType");
            return (Criteria) this;
        }

        public Criteria andPlanTypeLike(String value) {
            addCriterion("plan_type like", value, "planType");
            return (Criteria) this;
        }

        public Criteria andPlanTypeNotLike(String value) {
            addCriterion("plan_type not like", value, "planType");
            return (Criteria) this;
        }

        public Criteria andPlanTypeIn(List<String> values) {
            addCriterion("plan_type in", values, "planType");
            return (Criteria) this;
        }

        public Criteria andPlanTypeNotIn(List<String> values) {
            addCriterion("plan_type not in", values, "planType");
            return (Criteria) this;
        }

        public Criteria andPlanTypeBetween(String value1, String value2) {
            addCriterion("plan_type between", value1, value2, "planType");
            return (Criteria) this;
        }

        public Criteria andPlanTypeNotBetween(String value1, String value2) {
            addCriterion("plan_type not between", value1, value2, "planType");
            return (Criteria) this;
        }

        public Criteria andTaskTypeIsNull() {
            addCriterion("task_type is null");
            return (Criteria) this;
        }

        public Criteria andTaskTypeIsNotNull() {
            addCriterion("task_type is not null");
            return (Criteria) this;
        }

        public Criteria andTaskTypeEqualTo(String value) {
            addCriterion("task_type =", value, "taskType");
            return (Criteria) this;
        }

        public Criteria andTaskTypeNotEqualTo(String value) {
            addCriterion("task_type <>", value, "taskType");
            return (Criteria) this;
        }

        public Criteria andTaskTypeGreaterThan(String value) {
            addCriterion("task_type >", value, "taskType");
            return (Criteria) this;
        }

        public Criteria andTaskTypeGreaterThanOrEqualTo(String value) {
            addCriterion("task_type >=", value, "taskType");
            return (Criteria) this;
        }

        public Criteria andTaskTypeLessThan(String value) {
            addCriterion("task_type <", value, "taskType");
            return (Criteria) this;
        }

        public Criteria andTaskTypeLessThanOrEqualTo(String value) {
            addCriterion("task_type <=", value, "taskType");
            return (Criteria) this;
        }

        public Criteria andTaskTypeLike(String value) {
            addCriterion("task_type like", value, "taskType");
            return (Criteria) this;
        }

        public Criteria andTaskTypeNotLike(String value) {
            addCriterion("task_type not like", value, "taskType");
            return (Criteria) this;
        }

        public Criteria andTaskTypeIn(List<String> values) {
            addCriterion("task_type in", values, "taskType");
            return (Criteria) this;
        }

        public Criteria andTaskTypeNotIn(List<String> values) {
            addCriterion("task_type not in", values, "taskType");
            return (Criteria) this;
        }

        public Criteria andTaskTypeBetween(String value1, String value2) {
            addCriterion("task_type between", value1, value2, "taskType");
            return (Criteria) this;
        }

        public Criteria andTaskTypeNotBetween(String value1, String value2) {
            addCriterion("task_type not between", value1, value2, "taskType");
            return (Criteria) this;
        }

        public Criteria andPlanStatusIsNull() {
            addCriterion("plan_status is null");
            return (Criteria) this;
        }

        public Criteria andPlanStatusIsNotNull() {
            addCriterion("plan_status is not null");
            return (Criteria) this;
        }

        public Criteria andPlanStatusEqualTo(String value) {
            addCriterion("plan_status =", value, "planStatus");
            return (Criteria) this;
        }

        public Criteria andPlanStatusNotEqualTo(String value) {
            addCriterion("plan_status <>", value, "planStatus");
            return (Criteria) this;
        }

        public Criteria andPlanStatusGreaterThan(String value) {
            addCriterion("plan_status >", value, "planStatus");
            return (Criteria) this;
        }

        public Criteria andPlanStatusGreaterThanOrEqualTo(String value) {
            addCriterion("plan_status >=", value, "planStatus");
            return (Criteria) this;
        }

        public Criteria andPlanStatusLessThan(String value) {
            addCriterion("plan_status <", value, "planStatus");
            return (Criteria) this;
        }

        public Criteria andPlanStatusLessThanOrEqualTo(String value) {
            addCriterion("plan_status <=", value, "planStatus");
            return (Criteria) this;
        }

        public Criteria andPlanStatusLike(String value) {
            addCriterion("plan_status like", value, "planStatus");
            return (Criteria) this;
        }

        public Criteria andPlanStatusNotLike(String value) {
            addCriterion("plan_status not like", value, "planStatus");
            return (Criteria) this;
        }

        public Criteria andPlanStatusIn(List<String> values) {
            addCriterion("plan_status in", values, "planStatus");
            return (Criteria) this;
        }

        public Criteria andPlanStatusNotIn(List<String> values) {
            addCriterion("plan_status not in", values, "planStatus");
            return (Criteria) this;
        }

        public Criteria andPlanStatusBetween(String value1, String value2) {
            addCriterion("plan_status between", value1, value2, "planStatus");
            return (Criteria) this;
        }

        public Criteria andPlanStatusNotBetween(String value1, String value2) {
            addCriterion("plan_status not between", value1, value2, "planStatus");
            return (Criteria) this;
        }

        public Criteria andPlanWgCodeIsNull() {
            addCriterion("plan_wg_code is null");
            return (Criteria) this;
        }

        public Criteria andPlanWgCodeIsNotNull() {
            addCriterion("plan_wg_code is not null");
            return (Criteria) this;
        }

        public Criteria andPlanWgCodeEqualTo(String value) {
            addCriterion("plan_wg_code =", value, "planWgCode");
            return (Criteria) this;
        }

        public Criteria andPlanWgCodeNotEqualTo(String value) {
            addCriterion("plan_wg_code <>", value, "planWgCode");
            return (Criteria) this;
        }

        public Criteria andPlanWgCodeGreaterThan(String value) {
            addCriterion("plan_wg_code >", value, "planWgCode");
            return (Criteria) this;
        }

        public Criteria andPlanWgCodeGreaterThanOrEqualTo(String value) {
            addCriterion("plan_wg_code >=", value, "planWgCode");
            return (Criteria) this;
        }

        public Criteria andPlanWgCodeLessThan(String value) {
            addCriterion("plan_wg_code <", value, "planWgCode");
            return (Criteria) this;
        }

        public Criteria andPlanWgCodeLessThanOrEqualTo(String value) {
            addCriterion("plan_wg_code <=", value, "planWgCode");
            return (Criteria) this;
        }

        public Criteria andPlanWgCodeLike(String value) {
            addCriterion("plan_wg_code like", value, "planWgCode");
            return (Criteria) this;
        }

        public Criteria andPlanWgCodeNotLike(String value) {
            addCriterion("plan_wg_code not like", value, "planWgCode");
            return (Criteria) this;
        }

        public Criteria andPlanWgCodeIn(List<String> values) {
            addCriterion("plan_wg_code in", values, "planWgCode");
            return (Criteria) this;
        }

        public Criteria andPlanWgCodeNotIn(List<String> values) {
            addCriterion("plan_wg_code not in", values, "planWgCode");
            return (Criteria) this;
        }

        public Criteria andPlanWgCodeBetween(String value1, String value2) {
            addCriterion("plan_wg_code between", value1, value2, "planWgCode");
            return (Criteria) this;
        }

        public Criteria andPlanWgCodeNotBetween(String value1, String value2) {
            addCriterion("plan_wg_code not between", value1, value2, "planWgCode");
            return (Criteria) this;
        }

        public Criteria andStartTimeIsNull() {
            addCriterion("start_time is null");
            return (Criteria) this;
        }

        public Criteria andStartTimeIsNotNull() {
            addCriterion("start_time is not null");
            return (Criteria) this;
        }

        public Criteria andStartTimeEqualTo(String value) {
            addCriterion("start_time =", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotEqualTo(String value) {
            addCriterion("start_time <>", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeGreaterThan(String value) {
            addCriterion("start_time >", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeGreaterThanOrEqualTo(String value) {
            addCriterion("start_time >=", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeLessThan(String value) {
            addCriterion("start_time <", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeLessThanOrEqualTo(String value) {
            addCriterion("start_time <=", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeLike(String value) {
            addCriterion("start_time like", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotLike(String value) {
            addCriterion("start_time not like", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeIn(List<String> values) {
            addCriterion("start_time in", values, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotIn(List<String> values) {
            addCriterion("start_time not in", values, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeBetween(String value1, String value2) {
            addCriterion("start_time between", value1, value2, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotBetween(String value1, String value2) {
            addCriterion("start_time not between", value1, value2, "startTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeIsNull() {
            addCriterion("end_time is null");
            return (Criteria) this;
        }

        public Criteria andEndTimeIsNotNull() {
            addCriterion("end_time is not null");
            return (Criteria) this;
        }

        public Criteria andEndTimeEqualTo(String value) {
            addCriterion("end_time =", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotEqualTo(String value) {
            addCriterion("end_time <>", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeGreaterThan(String value) {
            addCriterion("end_time >", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeGreaterThanOrEqualTo(String value) {
            addCriterion("end_time >=", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeLessThan(String value) {
            addCriterion("end_time <", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeLessThanOrEqualTo(String value) {
            addCriterion("end_time <=", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeLike(String value) {
            addCriterion("end_time like", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotLike(String value) {
            addCriterion("end_time not like", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeIn(List<String> values) {
            addCriterion("end_time in", values, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotIn(List<String> values) {
            addCriterion("end_time not in", values, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeBetween(String value1, String value2) {
            addCriterion("end_time between", value1, value2, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotBetween(String value1, String value2) {
            addCriterion("end_time not between", value1, value2, "endTime");
            return (Criteria) this;
        }

        public Criteria andUnlimitedIsNull() {
            addCriterion("unlimited is null");
            return (Criteria) this;
        }

        public Criteria andUnlimitedIsNotNull() {
            addCriterion("unlimited is not null");
            return (Criteria) this;
        }

        public Criteria andUnlimitedEqualTo(String value) {
            addCriterion("unlimited =", value, "unlimited");
            return (Criteria) this;
        }

        public Criteria andUnlimitedNotEqualTo(String value) {
            addCriterion("unlimited <>", value, "unlimited");
            return (Criteria) this;
        }

        public Criteria andUnlimitedGreaterThan(String value) {
            addCriterion("unlimited >", value, "unlimited");
            return (Criteria) this;
        }

        public Criteria andUnlimitedGreaterThanOrEqualTo(String value) {
            addCriterion("unlimited >=", value, "unlimited");
            return (Criteria) this;
        }

        public Criteria andUnlimitedLessThan(String value) {
            addCriterion("unlimited <", value, "unlimited");
            return (Criteria) this;
        }

        public Criteria andUnlimitedLessThanOrEqualTo(String value) {
            addCriterion("unlimited <=", value, "unlimited");
            return (Criteria) this;
        }

        public Criteria andUnlimitedLike(String value) {
            addCriterion("unlimited like", value, "unlimited");
            return (Criteria) this;
        }

        public Criteria andUnlimitedNotLike(String value) {
            addCriterion("unlimited not like", value, "unlimited");
            return (Criteria) this;
        }

        public Criteria andUnlimitedIn(List<String> values) {
            addCriterion("unlimited in", values, "unlimited");
            return (Criteria) this;
        }

        public Criteria andUnlimitedNotIn(List<String> values) {
            addCriterion("unlimited not in", values, "unlimited");
            return (Criteria) this;
        }

        public Criteria andUnlimitedBetween(String value1, String value2) {
            addCriterion("unlimited between", value1, value2, "unlimited");
            return (Criteria) this;
        }

        public Criteria andUnlimitedNotBetween(String value1, String value2) {
            addCriterion("unlimited not between", value1, value2, "unlimited");
            return (Criteria) this;
        }

        public Criteria andPlanAllNumIsNull() {
            addCriterion("plan_all_num is null");
            return (Criteria) this;
        }

        public Criteria andPlanAllNumIsNotNull() {
            addCriterion("plan_all_num is not null");
            return (Criteria) this;
        }

        public Criteria andPlanAllNumEqualTo(Long value) {
            addCriterion("plan_all_num =", value, "planAllNum");
            return (Criteria) this;
        }

        public Criteria andPlanAllNumNotEqualTo(Long value) {
            addCriterion("plan_all_num <>", value, "planAllNum");
            return (Criteria) this;
        }

        public Criteria andPlanAllNumGreaterThan(Long value) {
            addCriterion("plan_all_num >", value, "planAllNum");
            return (Criteria) this;
        }

        public Criteria andPlanAllNumGreaterThanOrEqualTo(Long value) {
            addCriterion("plan_all_num >=", value, "planAllNum");
            return (Criteria) this;
        }

        public Criteria andPlanAllNumLessThan(Long value) {
            addCriterion("plan_all_num <", value, "planAllNum");
            return (Criteria) this;
        }

        public Criteria andPlanAllNumLessThanOrEqualTo(Long value) {
            addCriterion("plan_all_num <=", value, "planAllNum");
            return (Criteria) this;
        }

        public Criteria andPlanAllNumIn(List<Long> values) {
            addCriterion("plan_all_num in", values, "planAllNum");
            return (Criteria) this;
        }

        public Criteria andPlanAllNumNotIn(List<Long> values) {
            addCriterion("plan_all_num not in", values, "planAllNum");
            return (Criteria) this;
        }

        public Criteria andPlanAllNumBetween(Long value1, Long value2) {
            addCriterion("plan_all_num between", value1, value2, "planAllNum");
            return (Criteria) this;
        }

        public Criteria andPlanAllNumNotBetween(Long value1, Long value2) {
            addCriterion("plan_all_num not between", value1, value2, "planAllNum");
            return (Criteria) this;
        }

        public Criteria andPlanComNumIsNull() {
            addCriterion("plan_com_num is null");
            return (Criteria) this;
        }

        public Criteria andPlanComNumIsNotNull() {
            addCriterion("plan_com_num is not null");
            return (Criteria) this;
        }

        public Criteria andPlanComNumEqualTo(Long value) {
            addCriterion("plan_com_num =", value, "planComNum");
            return (Criteria) this;
        }

        public Criteria andPlanComNumNotEqualTo(Long value) {
            addCriterion("plan_com_num <>", value, "planComNum");
            return (Criteria) this;
        }

        public Criteria andPlanComNumGreaterThan(Long value) {
            addCriterion("plan_com_num >", value, "planComNum");
            return (Criteria) this;
        }

        public Criteria andPlanComNumGreaterThanOrEqualTo(Long value) {
            addCriterion("plan_com_num >=", value, "planComNum");
            return (Criteria) this;
        }

        public Criteria andPlanComNumLessThan(Long value) {
            addCriterion("plan_com_num <", value, "planComNum");
            return (Criteria) this;
        }

        public Criteria andPlanComNumLessThanOrEqualTo(Long value) {
            addCriterion("plan_com_num <=", value, "planComNum");
            return (Criteria) this;
        }

        public Criteria andPlanComNumIn(List<Long> values) {
            addCriterion("plan_com_num in", values, "planComNum");
            return (Criteria) this;
        }

        public Criteria andPlanComNumNotIn(List<Long> values) {
            addCriterion("plan_com_num not in", values, "planComNum");
            return (Criteria) this;
        }

        public Criteria andPlanComNumBetween(Long value1, Long value2) {
            addCriterion("plan_com_num between", value1, value2, "planComNum");
            return (Criteria) this;
        }

        public Criteria andPlanComNumNotBetween(Long value1, Long value2) {
            addCriterion("plan_com_num not between", value1, value2, "planComNum");
            return (Criteria) this;
        }

        public Criteria andPlanShopNumIsNull() {
            addCriterion("plan_shop_num is null");
            return (Criteria) this;
        }

        public Criteria andPlanShopNumIsNotNull() {
            addCriterion("plan_shop_num is not null");
            return (Criteria) this;
        }

        public Criteria andPlanShopNumEqualTo(Long value) {
            addCriterion("plan_shop_num =", value, "planShopNum");
            return (Criteria) this;
        }

        public Criteria andPlanShopNumNotEqualTo(Long value) {
            addCriterion("plan_shop_num <>", value, "planShopNum");
            return (Criteria) this;
        }

        public Criteria andPlanShopNumGreaterThan(Long value) {
            addCriterion("plan_shop_num >", value, "planShopNum");
            return (Criteria) this;
        }

        public Criteria andPlanShopNumGreaterThanOrEqualTo(Long value) {
            addCriterion("plan_shop_num >=", value, "planShopNum");
            return (Criteria) this;
        }

        public Criteria andPlanShopNumLessThan(Long value) {
            addCriterion("plan_shop_num <", value, "planShopNum");
            return (Criteria) this;
        }

        public Criteria andPlanShopNumLessThanOrEqualTo(Long value) {
            addCriterion("plan_shop_num <=", value, "planShopNum");
            return (Criteria) this;
        }

        public Criteria andPlanShopNumIn(List<Long> values) {
            addCriterion("plan_shop_num in", values, "planShopNum");
            return (Criteria) this;
        }

        public Criteria andPlanShopNumNotIn(List<Long> values) {
            addCriterion("plan_shop_num not in", values, "planShopNum");
            return (Criteria) this;
        }

        public Criteria andPlanShopNumBetween(Long value1, Long value2) {
            addCriterion("plan_shop_num between", value1, value2, "planShopNum");
            return (Criteria) this;
        }

        public Criteria andPlanShopNumNotBetween(Long value1, Long value2) {
            addCriterion("plan_shop_num not between", value1, value2, "planShopNum");
            return (Criteria) this;
        }

        public Criteria andPlanHouseNumIsNull() {
            addCriterion("plan_house_num is null");
            return (Criteria) this;
        }

        public Criteria andPlanHouseNumIsNotNull() {
            addCriterion("plan_house_num is not null");
            return (Criteria) this;
        }

        public Criteria andPlanHouseNumEqualTo(Long value) {
            addCriterion("plan_house_num =", value, "planHouseNum");
            return (Criteria) this;
        }

        public Criteria andPlanHouseNumNotEqualTo(Long value) {
            addCriterion("plan_house_num <>", value, "planHouseNum");
            return (Criteria) this;
        }

        public Criteria andPlanHouseNumGreaterThan(Long value) {
            addCriterion("plan_house_num >", value, "planHouseNum");
            return (Criteria) this;
        }

        public Criteria andPlanHouseNumGreaterThanOrEqualTo(Long value) {
            addCriterion("plan_house_num >=", value, "planHouseNum");
            return (Criteria) this;
        }

        public Criteria andPlanHouseNumLessThan(Long value) {
            addCriterion("plan_house_num <", value, "planHouseNum");
            return (Criteria) this;
        }

        public Criteria andPlanHouseNumLessThanOrEqualTo(Long value) {
            addCriterion("plan_house_num <=", value, "planHouseNum");
            return (Criteria) this;
        }

        public Criteria andPlanHouseNumIn(List<Long> values) {
            addCriterion("plan_house_num in", values, "planHouseNum");
            return (Criteria) this;
        }

        public Criteria andPlanHouseNumNotIn(List<Long> values) {
            addCriterion("plan_house_num not in", values, "planHouseNum");
            return (Criteria) this;
        }

        public Criteria andPlanHouseNumBetween(Long value1, Long value2) {
            addCriterion("plan_house_num between", value1, value2, "planHouseNum");
            return (Criteria) this;
        }

        public Criteria andPlanHouseNumNotBetween(Long value1, Long value2) {
            addCriterion("plan_house_num not between", value1, value2, "planHouseNum");
            return (Criteria) this;
        }

        public Criteria andPlanPeopleNumIsNull() {
            addCriterion("plan_people_num is null");
            return (Criteria) this;
        }

        public Criteria andPlanPeopleNumIsNotNull() {
            addCriterion("plan_people_num is not null");
            return (Criteria) this;
        }

        public Criteria andPlanPeopleNumEqualTo(Long value) {
            addCriterion("plan_people_num =", value, "planPeopleNum");
            return (Criteria) this;
        }

        public Criteria andPlanPeopleNumNotEqualTo(Long value) {
            addCriterion("plan_people_num <>", value, "planPeopleNum");
            return (Criteria) this;
        }

        public Criteria andPlanPeopleNumGreaterThan(Long value) {
            addCriterion("plan_people_num >", value, "planPeopleNum");
            return (Criteria) this;
        }

        public Criteria andPlanPeopleNumGreaterThanOrEqualTo(Long value) {
            addCriterion("plan_people_num >=", value, "planPeopleNum");
            return (Criteria) this;
        }

        public Criteria andPlanPeopleNumLessThan(Long value) {
            addCriterion("plan_people_num <", value, "planPeopleNum");
            return (Criteria) this;
        }

        public Criteria andPlanPeopleNumLessThanOrEqualTo(Long value) {
            addCriterion("plan_people_num <=", value, "planPeopleNum");
            return (Criteria) this;
        }

        public Criteria andPlanPeopleNumIn(List<Long> values) {
            addCriterion("plan_people_num in", values, "planPeopleNum");
            return (Criteria) this;
        }

        public Criteria andPlanPeopleNumNotIn(List<Long> values) {
            addCriterion("plan_people_num not in", values, "planPeopleNum");
            return (Criteria) this;
        }

        public Criteria andPlanPeopleNumBetween(Long value1, Long value2) {
            addCriterion("plan_people_num between", value1, value2, "planPeopleNum");
            return (Criteria) this;
        }

        public Criteria andPlanPeopleNumNotBetween(Long value1, Long value2) {
            addCriterion("plan_people_num not between", value1, value2, "planPeopleNum");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNull() {
            addCriterion("create_by is null");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNotNull() {
            addCriterion("create_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreateByEqualTo(String value) {
            addCriterion("create_by =", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotEqualTo(String value) {
            addCriterion("create_by <>", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThan(String value) {
            addCriterion("create_by >", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThanOrEqualTo(String value) {
            addCriterion("create_by >=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThan(String value) {
            addCriterion("create_by <", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThanOrEqualTo(String value) {
            addCriterion("create_by <=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLike(String value) {
            addCriterion("create_by like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotLike(String value) {
            addCriterion("create_by not like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByIn(List<String> values) {
            addCriterion("create_by in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotIn(List<String> values) {
            addCriterion("create_by not in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByBetween(String value1, String value2) {
            addCriterion("create_by between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotBetween(String value1, String value2) {
            addCriterion("create_by not between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNull() {
            addCriterion("update_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNotNull() {
            addCriterion("update_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateByEqualTo(String value) {
            addCriterion("update_by =", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotEqualTo(String value) {
            addCriterion("update_by <>", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThan(String value) {
            addCriterion("update_by >", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThanOrEqualTo(String value) {
            addCriterion("update_by >=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThan(String value) {
            addCriterion("update_by <", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThanOrEqualTo(String value) {
            addCriterion("update_by <=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLike(String value) {
            addCriterion("update_by like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotLike(String value) {
            addCriterion("update_by not like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByIn(List<String> values) {
            addCriterion("update_by in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotIn(List<String> values) {
            addCriterion("update_by not in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByBetween(String value1, String value2) {
            addCriterion("update_by between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotBetween(String value1, String value2) {
            addCriterion("update_by not between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andIsValidIsNull() {
            addCriterion("is_valid is null");
            return (Criteria) this;
        }

        public Criteria andIsValidIsNotNull() {
            addCriterion("is_valid is not null");
            return (Criteria) this;
        }

        public Criteria andIsValidEqualTo(String value) {
            addCriterion("is_valid =", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidNotEqualTo(String value) {
            addCriterion("is_valid <>", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidGreaterThan(String value) {
            addCriterion("is_valid >", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidGreaterThanOrEqualTo(String value) {
            addCriterion("is_valid >=", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidLessThan(String value) {
            addCriterion("is_valid <", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidLessThanOrEqualTo(String value) {
            addCriterion("is_valid <=", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidLike(String value) {
            addCriterion("is_valid like", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidNotLike(String value) {
            addCriterion("is_valid not like", value, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidIn(List<String> values) {
            addCriterion("is_valid in", values, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidNotIn(List<String> values) {
            addCriterion("is_valid not in", values, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidBetween(String value1, String value2) {
            addCriterion("is_valid between", value1, value2, "isValid");
            return (Criteria) this;
        }

        public Criteria andIsValidNotBetween(String value1, String value2) {
            addCriterion("is_valid not between", value1, value2, "isValid");
            return (Criteria) this;
        }

        public Criteria andExceptionDescIsNull() {
            addCriterion("exception_desc is null");
            return (Criteria) this;
        }

        public Criteria andExceptionDescIsNotNull() {
            addCriterion("exception_desc is not null");
            return (Criteria) this;
        }

        public Criteria andExceptionDescEqualTo(String value) {
            addCriterion("exception_desc =", value, "exceptionDesc");
            return (Criteria) this;
        }

        public Criteria andExceptionDescNotEqualTo(String value) {
            addCriterion("exception_desc <>", value, "exceptionDesc");
            return (Criteria) this;
        }

        public Criteria andExceptionDescGreaterThan(String value) {
            addCriterion("exception_desc >", value, "exceptionDesc");
            return (Criteria) this;
        }

        public Criteria andExceptionDescGreaterThanOrEqualTo(String value) {
            addCriterion("exception_desc >=", value, "exceptionDesc");
            return (Criteria) this;
        }

        public Criteria andExceptionDescLessThan(String value) {
            addCriterion("exception_desc <", value, "exceptionDesc");
            return (Criteria) this;
        }

        public Criteria andExceptionDescLessThanOrEqualTo(String value) {
            addCriterion("exception_desc <=", value, "exceptionDesc");
            return (Criteria) this;
        }

        public Criteria andExceptionDescLike(String value) {
            addCriterion("exception_desc like", value, "exceptionDesc");
            return (Criteria) this;
        }

        public Criteria andExceptionDescNotLike(String value) {
            addCriterion("exception_desc not like", value, "exceptionDesc");
            return (Criteria) this;
        }

        public Criteria andExceptionDescIn(List<String> values) {
            addCriterion("exception_desc in", values, "exceptionDesc");
            return (Criteria) this;
        }

        public Criteria andExceptionDescNotIn(List<String> values) {
            addCriterion("exception_desc not in", values, "exceptionDesc");
            return (Criteria) this;
        }

        public Criteria andExceptionDescBetween(String value1, String value2) {
            addCriterion("exception_desc between", value1, value2, "exceptionDesc");
            return (Criteria) this;
        }

        public Criteria andExceptionDescNotBetween(String value1, String value2) {
            addCriterion("exception_desc not between", value1, value2, "exceptionDesc");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria implements Serializable {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion implements Serializable {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}